
/*  Sample Custom Member Functions to create and update Custom Membership registration and profile 

	  Required Table Structure for this example:
		CREATE TABLE `custom_memberinfo` (
		  `uid` mediumint(9) NOT NULL default '0',
		  `firstname` varchar(128) NOT NULL default '',
		  `lastname` varchar(128) NOT NULL default '',
		  `country` varchar(128) NOT NULL default '',
		  `company` varchar(128) NOT NULL default '',
		  KEY `uid` (`uid`)
		) TYPE=MyISAM;


	Note1: You also need to include a definition for the new table in lib-database.php 
	$_TABLES['custom_memberinfo'] = $_DB_table_prefix . 'custom_memberinfo';

	Note2: Enable CustomRegistration Feature in config.php
	$_CONF['custom_registration'] = true;  // Set to true if you have custom code

	Note3: This example requries a template file called memberdetail.thtml to be
	located under the path/system directory

	4 Functions have been provided that are called from the Core Geeklog User admin code
	- This works with User Moderation as well
	- Admin will see the new registration info when checking a members profile only
	- All other users will see the standard GL User profile information

*/

function custom_usercreate($uid) {
    global $_CONF,$_TABLES,$HTTP_POST_VARS;

// Note you will need to ensure all data is prepared correctly before inserts - as quotes may need to be escaped with addslashes()

    $firstname=addslashes($HTTP_POST_VARS['firstname']);
    $lastname =addslashes($HTTP_POST_VARS['lastname']);
    $country  =addslashes($HTTP_POST_VARS['country']);
    $company  =addslashes($HTTP_POST_VARS['company']);

    DB_query("INSERT INTO {$_TABLES['custom_memberinfo']} ("
            ." uid,firstname,lastname,country,company,last_update"
            .") VALUES ("
            ."$uid,'$firstname','$lastname','$country','$company',"
            ."NOW() )");
    DB_query("UPDATE {$_TABLES['users']} SET "
            ."email='{$HTTP_POST_VARS['email']}',"
            ."homepage='{$HTTP_POST_VARS['homepage']}',"
            ."fullname='$firstname $lastname' "
            ."WHERE uid=$uid");

    return true;

}

function custom_usersave($uid) {
    global $_CONF,$_TABLES,$HTTP_POST_VARS;

// Note you will need to ensure all data is prepared correctly before inserts - as quotes may need to be escaped with addslashes()

    $firstname=addslashes($HTTP_POST_VARS['firstname']);
    $lastname =addslashes($HTTP_POST_VARS['lastname']);
    $country  =addslashes($HTTP_POST_VARS['country']);
    $company  =addslashes($HTTP_POST_VARS['company']);
    $result = DB_query("SELECT * FROM {$_TABLES['custom_memberinfo']} WHERE uid = $uid ");
    $nrows = DB_numRows($result);
    if ($nrows == 0) { // no such user
       DB_query("INSERT INTO {$_TABLES['custom_memberinfo']} ("
               ." uid,firstname,lastname,country,company,last_update"
               .") VALUES ("
               ."$uid,'$firstname','$lastname','$country','$company',"
               ."NOW() )");
    } else {
       DB_query("UPDATE {$_TABLES['custom_memberinfo']} SET "
               ."firstname='$firstname',"
               ."lastname='$lastname',"
               ."country='$country',"
               ."company='$company',"
               ."last_update=NOW()  "
               ."WHERE uid=$uid");
    }
    DB_query("UPDATE {$_TABLES['users']} SET "
// not used ."fullname='{$HTTP_POST_VARS['firstname']} {$HTTP_POST_VARS['lastname']}' "
            ."email='{$HTTP_POST_VARS['email']}',"
            ."homepage='{$HTTP_POST_VARS['homepage']}' "
            ."WHERE uid=$uid");
    return true;

}

function custom_userdelete($uid) {
    global $_TABLES;
    DB_query("DELETE FROM {$_TABLES['custom_memberinfo']} WHERE uid=$uid");

    return true;
}

/* Main Form used for Custom membership to add/edit and display custom user form */
function custom_userform($mode,$uid="",$msg="") {
    global $_CONF,$_TABLES, $LANG04;
    if (!empty($msg)) {
       $retval .= COM_startBlock($LANG04[21]) . $msg . COM_endBlock();
    }

    if ($mode == "edit") {
        $post_url = $_CONF['site_url']."/usersettings.php";
        $postmode = "saveuser";
        $submitbutton = "<input type='submit' value='{$LANG04[9]}'>";
        $passwd_input = '<tr bgcolor="#FFFFFF">' . LB
                      . '<td align="right"><b>' .$LANG04[4]. '</b></td>' . LB
                      . '<td>&nbsp;</td>' . LB
                      . '<td><input type="password" name="passwd" size="25" maxlength="32" value=""></td>' . LB
                      . '<td>&nbsp;</td>' . LB
                      . '</tr>' . LB;
        $result = DB_query("SELECT * FROM {$_TABLES['users']} WHERE uid = $uid ");
        $A = DB_fetchArray($result);
        $result = DB_query("SELECT * FROM {$_TABLES['custom_memberinfo']} WHERE uid = $uid ");
        $B = DB_fetchArray($result);
        $message = "<br><font size=3><br></font><font size=2 color=black><b>{$LANG04[1]} {$A['username']}</b></font>";
    
    } elseif ($mode == "moderate" ) {
             $submitbutton = '<input type="button" value="Back" onclick="javascript:history.go(-1)">';
             $result = DB_query("SELECT * FROM {$_TABLES['users']} WHERE uid = $uid ");
             $A = DB_fetchArray($result);
             $result = DB_query("SELECT * FROM {$_TABLES['custom_memberinfo']} WHERE uid = $uid ");
             $B = DB_fetchArray($result);

    } else {
        $post_url = $_CONF['site_url']."/users.php";
        $postmode = "create";
        $submitbutton = "<font color=red>$LANG04[24]</font><br><input type='submit' value='{$LANG04[27]}'>";
        $passwd_input = "";
        $message = "<br><font size=2 color=black>$LANG04[23]</font>";
        $A=array();
        $B=array();
    }

/* changed !! line below was original !!

    $user_templates = new Template ($_CONF['path_layout'] . 'custom');
*/
    $user_templates = new Template ($_CONF['path'] . 'system');
    $user_templates->set_file('memberdetail', 'memberdetail.thtml');
    $user_templates->set_var('layout_url', $_CONF['layout_url']);
    $user_templates->set_var('post_url', $post_url);
    $user_templates->set_var('startblock', COM_startBlock("$LANG04[22]"));
    $user_templates->set_var('message', $message);    
    $user_templates->set_var('USERNAME', "$LANG04[2]");
    $user_templates->set_var('USERNAME_HELP', "");
    $user_templates->set_var('username', $A['username']);
    $user_templates->set_var('passwd_input', $passwd_input);
    $user_templates->set_var('FIRSTNAME', "");
    $user_templates->set_var('FIRSTNAME_HELP', "");
    $user_templates->set_var('firstname', $B['firstname']);
    $user_templates->set_var('LASTNAME', "");
    $user_templates->set_var('LASTNAME_HELP', "");
    $user_templates->set_var('lastname', $B['lastname']);
    $user_templates->set_var('COUNTRY', "Country");
    $user_templates->set_var('COUNTRY_HELP', "");
    $user_templates->set_var('country', $B['country']);
    $user_templates->set_var('EMAIL', "$LANG04[5]");
    $user_templates->set_var('EMAIL_HELP', "");
    $user_templates->set_var('email', $A['email']);
    $user_templates->set_var('HOMEPAGE', "website");
    $user_templates->set_var('HOMEPAGE_HELP', "$LANG04[36]");
    $user_templates->set_var('homepage', $A['homepage']);
    $user_templates->set_var('COMPANY', "");
    $user_templates->set_var('COMPANY_HELP', "");
    $user_templates->set_var('company', $B['company']);
    $user_templates->set_var('user_id', $user);
    $user_templates->set_var('postmode', $postmode);
    $user_templates->set_var('submitbutton', $submitbutton);
    $user_templates->set_var('endblock', COM_endBlock());
    if (!empty($A['photo']) AND $_CONF['allow_user_photo'] == 1) {
        $user_templates->set_var('user_photo','<img src="' . $_CONF['site_url'] . '/images/userphotos/' . $A['photo'] . '" alt="">');
    } else {
        $user_templates->set_var('user_photo','');
    }
    $user_templates->parse('output', 'memberdetail');
    $retval .= $user_templates->finish($user_templates->get_var('output'));

    return $retval;
}
